

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <usb.h>
// #include "libusb/include/usb.h"

#pragma BEGINDUMP
#pragma comment( lib, "libusb\lib\bcc\libusb.lib" )
#pragma ENDDUMP


#define MAX_INCOMING_BUFFER 1024

#define USB_RX_PULSE_DEF 31
#define USB_RX_PULSE 32
#define USB_RX_SPACE 33
#define USB_RX_PULSE_DEMOD 34
#define USB_RX_SPACE_DEMOD 35
#define USB_NO_DATA_BYTE 36

/* Prototypes  */
int commandir_rec(void);
int hardware_scan(void);
int commandir_send(char * packet, int bytes);
int commandir3_convert_RX(unsigned char *rxBuffer,
	int numNewValues);
void dump_signal(void);
struct sendir * tx_char_2_struct(char * buffer);
int commandir_sendir(struct sendir * tx);
char * load_file(char * filename);


/* CommandIR Internal Structs */
struct commandir_3_tx_signal
{
	unsigned short tx_bit_mask1;
	unsigned short tx_bit_mask2;
	unsigned short tx_min_gap;
	unsigned short tx_signal_count;
	unsigned short pulse_width;
	unsigned short pwm_offset;
};

struct usb_rx_space3 {
 unsigned short pca_overflow_count;
 unsigned short pca_offset;
};

struct usb_rx_pulse3 {
 unsigned short t0_count;
};

struct usb_rx_pulse_def3 {
 unsigned short frequency;
 unsigned short pwm;
};

struct usb_rx_demod_pulse {
 unsigned short pca_overflow_count;
 unsigned short pca_offset;
};

/* Struct for commandir_send()  */
struct sendir {
  int byteCount;
  char * buffer;
  int emitterMask;
};

#define USB_CMDIR_VENDOR_ID		0x10c4
#define PULSE_BIT 0x8000


